package com.fs.starfarer.api.impl.campaign.rulecmd;

import java.util.regex.Pattern;
import com.fs.starfarer.api.impl.campaign.fleets.EconomyFleetAssignmentAI;
import com.fs.starfarer.api.impl.campaign.fleets.RouteManager;
import com.fs.starfarer.api.campaign.econ.CommoditySpecAPI;
import java.util.ArrayList;
import kaysaar.aotd_question_of_loyalty.data.tags.AoTDRankTags;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import java.util.Iterator;
import java.util.HashMap;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.onetime.StoppingSmuggler;
import com.fs.starfarer.api.campaign.BattleAPI;
import com.fs.starfarer.api.campaign.CoreInteractionListener;
import com.fs.starfarer.api.Global;
import java.util.Random;
import com.fs.starfarer.api.util.Misc;
import java.util.List;
import com.fs.starfarer.api.characters.PersonAPI;
import java.util.Map;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.OptionPanelAPI;
import com.fs.starfarer.api.campaign.TextPanelAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;

public class AoTDSmugglerScan extends BaseCommandPlugin
{
    protected CampaignFleetAPI playerFleet;
    protected SectorEntityToken entity;
    protected FactionAPI playerFaction;
    protected FactionAPI entityFaction;
    protected TextPanelAPI text;
    protected OptionPanelAPI options;
    protected CampaignFleetAPI potentialSmuggler;
    protected CargoAPI playerCargo;
    protected MemoryAPI memory;
    protected InteractionDialogAPI dialog;
    protected Map<String, MemoryAPI> memoryMap;
    protected PersonAPI person;
    protected FactionAPI faction;
    
    public boolean execute(final String ruleId, final InteractionDialogAPI dialog, final List<Misc.Token> params, final Map<String, MemoryAPI> memoryMap) {
        this.dialog = dialog;
        this.memoryMap = memoryMap;
        final String command = params.get(0).getString((Map)memoryMap);
        if (command == null) {
            return false;
        }
        this.entity = dialog.getInteractionTarget();
        this.text = dialog.getTextPanel();
        this.options = dialog.getOptionPanel();
        this.person = dialog.getInteractionTarget().getActivePerson();
        this.faction = this.person.getFaction();
        this.potentialSmuggler = (CampaignFleetAPI)this.entity;
        if (command.equals("canCargoCheck")) {
            final boolean can = this.canCargoCheck();
            if (can && !this.entity.getMemory().is("$aotd_rand_completed", true)) {
                this.entity.getMemory().set("$aotd_rand_completed", (Object)true);
                final Random rand = Misc.getRandom(0L, 0);
                if (rand.nextFloat() >= 0.3) {
                    if (rand.nextFloat() >= 0.6) {
                        this.entity.getMemory().set("$aotd_bribery_check", (Object)true);
                    }
                    this.entity.getMemory().set("$aotd_will_found_cargo", (Object)true);
                }
                else {
                    this.entity.getMemory().set("$aotd_will_found_cargo", (Object)false);
                }
            }
            return can;
        }
        if (command.equals("getResultsOfScan")) {
            dialog.getOptionPanel().clearOptions();
            dialog.getTextPanel().addPara("Calmly laying down the facts you know, you inform the opposing fleet of your intentions to investigate potential smuggling activity in this area and will be boarding their vessels.");
            this.entity.getMemory().set("$aotd_checked_cargo", (Object)true);
            if (this.entity.getMemory().is("$aotd_will_found_cargo", true) && !this.getIllegalCargoAmount(this.potentialSmuggler, false).isEmpty()) {
                this.text.addPara("After conducting search through entire fleet a lot of contraband has been found by our officers");
                dialog.getOptionPanel().addOption("Confiscate entire contraband", (Object)"aotd_seize_cargo");
            }
            else {
                this.text.addPara("After conducting search through entire fleet we have not found any traces of illegal commodities.");
                dialog.getOptionPanel().addOption("We apologize for inconvenience", (Object)"cutCommLink");
            }
        }
        if (command.equals("pillage")) {
            this.pillage();
        }
        return true;
    }
    
    public void pillage() {
        final CargoAPI cargo = Global.getFactory().createCargo(false);
        final HashMap<String, Integer> cargoRaw = this.getIllegalCargoAmount((CampaignFleetAPI)this.entity, false);
        for (final Map.Entry<String, Integer> entry : cargoRaw.entrySet()) {
            cargo.addCommodity((String)entry.getKey(), (float)entry.getValue());
        }
        this.dialog.getVisualPanel().showLoot("Contraband", cargo, false, (CoreInteractionListener)new CoreInteractionListener() {
            public void coreUIDismissed() {
                AoTDSmugglerScan.this.getIllegalCargoAmount((CampaignFleetAPI)AoTDSmugglerScan.this.entity, true);
                ((CampaignFleetAPI)AoTDSmugglerScan.this.entity).getBattle().finish(BattleAPI.BattleSide.NO_JOIN);
                AoTDSmugglerScan.this.dialog.dismiss();
                AoTDSmugglerScan.this.dialog.hideTextPanel();
                AoTDSmugglerScan.this.dialog.hideVisualPanel();
                AoTDCommIntelPlugin.addFactorCreateIfNecessary((EventFactor)new StoppingSmuggler(80), (InteractionDialogAPI)null);
            }
        });
        this.options.clearOptions();
        this.dialog.setPromptText("");
    }
    
    public boolean canCargoCheck() {
        return QoLMisc.isInSpaceofCommisionedFaction() && !this.entity.getMemory().is("$aotd_checked_cargo", true) && this.entity.getMemory().is("$isSmuggler", true) && AoTDCommIntelPlugin.get().getCurrentRankData().hasTag(AoTDRankTags.CAN_SCAN_CARGO);
    }
    
    public ArrayList<CommoditySpecAPI> getIllegalCommoditiesForFaction(final FactionAPI faction) {
        final ArrayList<CommoditySpecAPI> illegal = new ArrayList<CommoditySpecAPI>();
        for (final String illegalCommodity : faction.getIllegalCommodities()) {
            illegal.add(Global.getSettings().getCommoditySpec(illegalCommodity));
        }
        return illegal;
    }
    
    public HashMap<String, Integer> getIllegalCargoAmount(final CampaignFleetAPI fleet, final boolean removeIt) {
        final RouteManager.RouteData data = RouteManager.getInstance().getRoute("econ", fleet);
        final EconomyFleetAssignmentAI.EconomyRouteData daten = (EconomyFleetAssignmentAI.EconomyRouteData)data.getCustom();
        List<EconomyFleetAssignmentAI.CargoQuantityData> listOfCommodities = new ArrayList<EconomyFleetAssignmentAI.CargoQuantityData>();
        final SectorEntityToken where = data.getCurrent().from;
        if (where.getMarket().getId().equals(daten.from.getId())) {
            listOfCommodities = daten.cargoDeliver;
        }
        else {
            listOfCommodities = daten.cargoReturn;
        }
        final HashMap<String, Integer> cargo = new HashMap<String, Integer>();
        final ArrayList<CommoditySpecAPI> illegal = this.getIllegalCommoditiesForFaction(Misc.getCommissionFaction());
        final Iterator<EconomyFleetAssignmentAI.CargoQuantityData> iter = listOfCommodities.iterator();
        while (iter.hasNext()) {
            final EconomyFleetAssignmentAI.CargoQuantityData datsa = iter.next();
            for (final CommoditySpecAPI commoditySpecAPI : illegal) {
                if (datsa.getCommodity().getId().equals(commoditySpecAPI.getId())) {
                    final int units = datsa.units;
                    cargo.put(datsa.getCommodity().getId(), (int)(units * datsa.getCommodity().getEconUnit()));
                    if (!removeIt) {
                        continue;
                    }
                    iter.remove();
                }
            }
        }
        if (removeIt) {
            if (listOfCommodities.isEmpty()) {
                data.expire();
                Misc.giveStandardReturnToSourceAssignments(fleet, true);
            }
            else {
                String text = fleet.getCurrentAssignment().getActionText();
                for (String s : cargo.keySet()) {
                    final String name = Global.getSettings().getCommoditySpec(s).getName();
                    final String pattern = "(?i)" + Pattern.quote(name);
                    text = text.replaceAll(pattern, "").replaceAll("\\s*,\\s*,", ",").trim();
                }
                text = text.replaceAll("\\s*,\\s*,", ",");
                text = text.replaceAll(",\\s*and\\s*,", " and ");
                text = text.replaceAll("\\s*,\\s*$", "");
                text = text.replaceAll("\\s*,\\s*and\\s*$", "");
                if (!text.isEmpty()) {
                    text = text.substring(0, 1).toUpperCase() + text.substring(1);
                }
                fleet.getCurrentAssignment().setActionText(text);
            }
        }
        return cargo;
    }
}
